from data.data import Data
from data.data_mod import DataMod
from data.data_obs import DataObs
from data.data_ensembles import DataEns
from dateutil.relativedelta import *
import os
import datetime
import copy
import shutil
import sys

def calc_seas_percent_nbdays(varini, per, explst, year1, year2, monstart):
    """ this function will calculate and write the output
    of the seasonal (between leadtime month 02 and 04)
    number of day and the percentile per for all years between year1
    and year2 for all exp in explst and all observation in obslist
    -var: the name of the input variable
    -explist: list of experiments or observations
    -year1: first years of the time period
    -year2: last years of the time period
    -monstrt: startmonth
    """
    
    
    date1=datetime.date(year1,monstart,1)
    date2=datetime.date(year2,monstart,1)

    dictcomp={10:"less", 90:"greater"}
    comp=dictcomp.get(per)

    #loop on experiments
    for expname in explst: 
        if (not os.path.isdir(workdir)):
            os.mkdir(workdir)
        os.chdir(workdir)

        #creating the object according to the type of experiment/observations
        if (exp in  ["EnsEcmwfSeas", "EnsIfmSeas","EnsCmccSeas", "EnsUkmoSeas"]):
            exp=DataEns(expname, varini)
        elif (exp in ["b0cm", "b0gq"]):
            exp=DataEC23(expname, varini)
        elif (exp in ["ERAint"]):
            d1_seas=date1+relativedelta(months=+1)
            d2_seas=date2+relativedelta(months=+1)
            listobs=list_season_obs(dataname, varini, d1_seas,d2_seas , 3)
            exp=concat_monthly_data(listobs, varini+"_01-04")

        exp.set_inputdirAuto() #look for the input directory
        exp.set_outputdirAuto() #look for the output directory
        exp.set_files(date1,date2) #look for the files between date1 and date2 
        exp.format_files_nc() #set file calendar
        exp.see()


        ######seasonal values#####


        leadtime1=relativedelta(months=+1)
        leadtime2=relativedelta(months=+4, days=-1)
        exp_season=exp.select_leadtime(leadtime1, leadtime2)

       #seasonal q10
        exp_stat2=exp_season.seasonal_percentile(10)
        varnew=exp_stat2.get_varname()
        exp_stat2.write_output(set_output_name(varnew))

        exp_stat3=exp_season.seasonal_nbday(10, comp)
        varnew=exp_stat3.get_varname()
        exp_stat3.write_output(set_output_name(varnew))

        shutil.rmtree(workdir) 
        
}
