import sys
def set_output_name(varini):
    """this function return the unit and 
    long name associated to varini
    arguments:
    - varini: variable shortname
    outputs:
    - unit
    - unit_long
    - long_name)"""
    
        unitdict={"tas":"K", "tasmin":"K", "tasmax":"K", 
                  "tasmin_q10":"K", "tasmax_q90":"K",
                  "prlr_01-04_nbdays_q90_19790601-20050831":"percent",
                  "prlr_01-04_nbdays_q90_19791201-20060228":"percent",
                  "prlr_01-04_q90":"m/s",
                  "prlr_nbdays_q90_19790501-20051031":"percent",
                  "prlr_nbdays_q90_19791101-20060430":"percent",
                  "prlr_q90":"m/s",
                  "tasmax_01-04_nbdays_q90_19790601-20050831":"percent",
                  "tasmax_01-04_nbdays_q90_19791201-20060228":"percent",
                  "tasmax_01-04_q90":"K",
                  "tasmax_nbdays_q90_19790501-20051031":"percent",
                  "tasmax_nbdays_q90_19791101-20060430":"percent",
                  "tasmax_q90":"K",
                  "tasmin_01-04_nbdays_q10_19790601-20050831":"percent",
                  "tasmin_01-04_nbdays_q10_19791201-20060228":"percent",
                  "tasmin_01-04_q10":"K",
                  "tasmin_nbdays_q10_19790501-20051031":"percent",
                  "tasmin_nbdays_q10_19791101-20060430":"percent",
                  "tasmin_q10":"K",
                  "prlr":"m/s"}

        unitlongdict={"tas":"Kelvin", "tasmin":"Kelvin", "tasmax":"Kelvin", 
                      "tasmin_q10":"Kelvin", "tasmax_q90":"Kelvin",
                      "prlr_01-04_nbdays_q90_19790601-20050831":"percentage",
                      "prlr_01-04_nbdays_q90_19791201-20060228":"percentage",
                      "prlr_01-04_q90":"m/s",
                      "prlr_nbdays_q90_19790501-20051031":"percentage",
                      "prlr_nbdays_q90_19791101-20060430":"percentage",
                      "prlr_q90":"m/s",
                      "tasmax_01-04_nbdays_q90_19790601-20050831":"percentage",
                      "tasmax_01-04_nbdays_q90_19791201-20060228":"percentage",
                      "tasmax_01-04_q90":"Kelvin",
                      "tasmax_nbdays_q90_19790501-20051031":"percentage",
                      "tasmax_nbdays_q90_19791101-20060430":"percentage",
                      "tasmax_q90":"Kelvin",
                      "tasmin_01-04_nbdays_q10_19790601-20050831":"percentage",
                      "tasmin_01-04_nbdays_q10_19791201-20060228":"percentage",
                      "tasmin_01-04_q10":"Kelvin",
                      "tasmin_nbdays_q10_19790501-20051031":"percentage",
                      "tasmin_nbdays_q10_19791101-20060430":"percentage",
                      "tasmin_q10":"Kelvin",
                      "prlr":"m/s"}

        tas="daily 2m temperature "
        prlr="daily precipitation "
        tasmin="daily minimum 2m temperature "
        tasmax="daily maximum 2m temperature "
        q10="10th percentile of "
        q90="90th percentile of "
        nbdays_q90="percentage of days greater than the climatological "+q90
        nbdays_q10="percentage of days less than the climatological "+q90
        s01-04="between leadtime month 02 and 04"

        varlongdict={"tas":tas, 
                     "tasmin":tasmin,
                     "tasmax":tasmax,
                     "prlr":prlr,
                     "tasmin_q10":
                         q10+tasmin, 
                     "tasmax_q90":
                         q90+tasmax, 
                     "prlr_01-04_nbdays_q90_19790601-20050831":
                         nbdays_q90+prlr+s01-04,
                     "prlr_01-04_nbdays_q90_19791201-20060228":
                         nbdays_q90+prlr+s01-04,
                     "prlr_01-04_q90":q90+prlr+s01-04,
                     "prlr_nbdays_q90_19790501-20051031":
                         nbdays_q90+prlr,
                     "prlr_nbdays_q90_19791101-20060430":
                         nbdays_q90+prlr,
                     "prlr_q90":
                         q90+prlr,
                     "tasmax_01-04_nbdays_q90_19790601-20050831":
                         nbdays_q90+tasmax+s01-04,
                     "tasmax_01-04_nbdays_q90_19791201-20060228":
                         nbdays_q90+tasmax+s01-04,
                     "tasmax_01-04_q90":
                         q90+tasmax+s01-04,
                     "tasmax_nbdays_q90_19790501-20051031":
                         nbdays_q90+tasmax,
                     "tasmax_nbdays_q90_19791101-20060430":
                         nbdays_q90+tasmax,
                     "tasmax_q90":
                         q90+tasmax,
                     "tasmin_01-04_nbdays_q10_19790601-20050831":
                         nbdays_q10+tasmin+s01-04,
                     "tasmin_01-04_nbdays_q10_19791201-20060228":
                         nbdays_q10+tasmin+s01-04,
                     "tasmin_01-04_q10":
                         q10+tasmin+s01-04,
                    "tasmin_nbdays_q10_19790501-20051031":
                         nbdays_q10+tasmin,
                     "tasmin_nbdays_q10_19791101-20060430":
                         nbdays_q10+tasmin,
                     "tasmin_q10":
                         q10+tasmin}
        try: 
            unit=unitdict.get(varini)
            unit_long=unitlongdict.get(varini)
            long_name=varlongdict.get(varini)
        except:
            print("the variable "+varini+"is no available in the set_output_name function")
            sys.exit(0)
        
        return(unit,unit_long,long_name)
